<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: Moco Theory Guide</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('mocotheoryguide.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Moco Theory Guide </div>  </div>
</div><!--header-->
<div class="contents">
<div class="toc"><h3>Table of Contents</h3>
<ul><li class="level1"><a href="#mocoocp">Optimal control problem</a><ul><li class="level2"><a href="#mocopreskintheory">Prescribed kinematics</a></li>
</ul>
</li>
<li class="level1"><a href="#dircol">Direct collocation</a><ul><li class="level2"><a href="#mocotraptheory">Trapezoidal transcription</a></li>
<li class="level2"><a href="#mocohermitesimpsontheory">Hermite–Simpson transcription</a></li>
</ul>
</li>
</ul>
</div>
<div class="textblock"><p>This guide explains the type of optimal control problems Moco can solve, in mathematical form, and how these problems are transcribed into nonlinear optimization problems.</p>
<h1><a class="anchor" id="mocoocp"></a>
Optimal control problem</h1>
<p>The most generic problem that Moco solves can be expressed as follows:</p>
<p class="formulaDsp">
\[ \begin{align} \begin{aligned} \mbox{minimize} \quad &amp; \sum_j w_{j} J_{j}(t_0, t_f, y_0, y_f, x_{0}, x_{f}, \lambda_0, \lambda_f, p, S_{c,j}) &amp;&amp; \textrm{costs} \\ &amp; \quad\quad S_{c,j} = \int_{t_0}^{t_f} s_{c,j}(t, y, x, \lambda, p)\,dt \\ \mbox{subject to} \quad &amp; \dot{q} = u \\ &amp; M(q, p)\dot{u} + G(q, p)^T \lambda = f_{\mathrm{app}}(t, y, x, p) - f_{\mathrm{inertial}}(q, u, p) &amp;&amp; \textrm{multibody dynamics} \\ &amp; \dot{z}_\textrm{ex}(t) = f_{\dot{z},\textrm{ex}}(t, y, x, \lambda, p) &amp;&amp; \textrm{auxiliary dynamics, explicit} \\ &amp; 0 = f_{\dot{z},\textrm{im}}(t, y, \dot{z}_{\textrm{im}}, x, \lambda, p) &amp;&amp; \textrm{auxiliary dynamics, implicit}\\ &amp; 0 = \phi(q, p) &amp;&amp; \textrm{kinematic constraints} \\ &amp; V_{L,k} \leq V_k(t_0, t_f, y_0, y_f, x_{0}, x_{f}, \lambda_0, \lambda_f, p, S_{b,k}) \leq V_{U,k} &amp;&amp; \textrm{boundary constraints} \\ &amp; \quad\quad S_{b,k} = \int_{t_0}^{t_f} s_{b,k}(t, y, x, \lambda, p)\,dt \quad k = 1, \ldots, K\\ &amp; g_{L} \leq g(t, y, x, \lambda, p) \leq g_{U} &amp;&amp; \textrm{path constraints} \\ &amp; y_{0,L} \leq y_0 \leq y_{0,U} \quad\quad y_{f,L} \leq y_f \leq y_{f,U} &amp;&amp; \textrm{initial and final states} \\ &amp; x_{0,L} \leq x_0 \leq x_{0,U} \quad\quad x_{f,L} \leq x_f \leq x_{f,U} &amp;&amp; \textrm{initial and final controls} \\ \mbox{with respect to} \quad &amp; t_0 \in [t_{0,L}, t_{0,U}] &amp;&amp; \textrm{initial time} \\ &amp; t_f \in [t_{f,L}, t_{f,U}] &amp;&amp; \textrm{final time} \\ &amp; y(t) = (q(t), u(t), z(t)) \in [y_{L}, y_{U}] &amp;&amp; \textrm{states} \\ &amp; x(t) \in [x_{L}, x_{U}] &amp;&amp; \textrm{controls} \\ &amp; \lambda(t) &amp;&amp; \textrm{Lagrange multipliers} \\ &amp; p \in [p_{L}, p_{U}] &amp;&amp; \textrm{time-invariant parameters} \end{aligned} \end{align} \]
</p>
<p>We use the following notation:</p>
<ul>
<li>\( t \): time</li>
<li>\( q(t) \): generalized coordinates</li>
<li>\( u(t) \): generalized speeds</li>
<li>\( z(t) \): auxiliary states (muscle fiber length and activation)</li>
<li>\( z_{\textrm{ex}}(t) \): the subset of \( z(t) \) with explicit differential equations</li>
<li>\( z_{\textrm{im}}(t) \): the subset of \( z(t) \) with implicit differential equations</li>
<li>\( y(t) = (q(t), u(t), z(t))\)</li>
<li>\( x(t) \): controls (including muscle excitation)</li>
<li>\( p \): constant parameters</li>
<li>\( \lambda \): kinematic constraint multipliers</li>
<li>\( w_j \): weight for \( j \)-th cost goal</li>
<li>\( J_{j} \): the \( j \)-th cost goal</li>
<li>\( s_{c,j} \): integrand used in the \( j \)-th cost goal</li>
<li>\( S_{c,j} \): integral of \( s_{c,j} \)</li>
<li>\( M \): mass matrix</li>
<li>\( f_{\textrm{inertial}} \): centripetal and coriolis forces</li>
<li>\( G \): kinematic constraint Jacobian</li>
<li>\( f_{\textrm{app}} \): applied forces (gravity, muscles, etc.)</li>
<li>\( f_{\textrm{aux},\textrm{ex}} \): explicit auxiliary dynamics (muscle activation dynamics, etc.)</li>
<li>\( f_{\textrm{aux},\textrm{im}} \): implicit auxiliary dynamics (<a class="el" href="classOpenSim_1_1DeGrooteFregly2016Muscle.html" title="This muscle model was published in De Groote et al.">DeGrooteFregly2016Muscle</a>'s tendon compliance dynamics)</li>
<li>\( \phi \): position-level (holonomic) kinematic constraints</li>
<li>\( \nu \): velocity-level (non-holonomic) kinematic constraints</li>
<li>\( \alpha \): acceleration-level kinematic constraints</li>
<li>\( V_k \): the \( k \)-th boundary constraint goal</li>
<li>\( s_{b,k} \): the integrand used in the \( k \)-th boundary constraint goal</li>
<li>\( S_{b,k} \): the integral of \( s_{b,k} \)</li>
<li>\( K \): number of boundary constraint goals</li>
<li>\( g \): path constraints</li>
<li>subscript \( U \): an upper bound</li>
<li>subscript \( L \): a lower bound</li>
</ul>
<p>In Moco, "goals", such as tracking marker data or effort, can be enforced either as cost terms to minimize or boundary constraints.</p>
<p>Auxiliary dynamics are typically used for muscle activation dynamics and fiber dynamics. In Moco, these dynamics can be expressed with explicit differential equations, where the derivative of the auxiliary state variable is on the left hand side of the dynamics equations, or implicit differential equations, where the derivative of the auxiliary state variable is an input to a residual equation (i.e., the left hand side is 0). Note that the explicit auxiliary differential equations can depend on any auxiliary state variable, even on a variable whose dynamics are enforced with an implicit differential equation. Similarly, the implicit differential equations can depend on any of the auxiliary state variables.</p>
<h2><a class="anchor" id="mocopreskintheory"></a>
Prescribed kinematics</h2>
<p>Simbody provides two mechanisms for prescribing the value of a coordinate: adding a constraint with SimTK::Constraint::PrescribedMotion (see <a class="el" href="classOpenSim_1_1Coordinate.html" title="A Coordinate is a ModelComponent for managing the access and behavior of a model&#39;s generalized coordi...">Coordinate</a>'s prescribed and prescribed_function properties), and removing a degree of freedom using SimTK::Motion. The former leads to a bigger system of equations (and does not avoid multibody dynamics), while the latter results in a smaller system of equations. In Moco, we use the <a class="el" href="classOpenSim_1_1PositionMotion.html" title="This class prescribes the value, speed, and acceleration of all coordinates in the model using SimTK:...">PositionMotion</a> component (which uses SimTK::Motion) to prescribe the motion of all degrees of freedom using spline functions, as this leads to a more tractable direct collocation problem that often converges reliably and in far less time than a problem containing multibody dynamics.</p>
<p>In this formulation, the kinematic variables \( q \) and \( u \) are replaced with known quantities \( \hat{q} \) and \( \hat{u} \):</p>
<p class="formulaDsp">
\[ \begin{align} \begin{aligned} \mbox{minimize} \quad &amp; \sum_j w_j J_{j}(t_0, t_f, \hat{q}_0, \hat{q}_f, \hat{u}_0, \hat{u}_f, z_0, z_f, x_{0}, x_{f}, \lambda_0, \lambda_f, p, S_{c,j}) &amp;&amp; \textrm{costs} \\ &amp; \quad\quad S_{c,j} = \int_{t_0}^{t_f} s_{c,j}(t, \hat{q}, \hat{u}, z, x, \lambda, p)~dt \\ \mbox{subject to} \quad &amp; M(\hat{q}, p)\hat{\dot{u}} + G(\hat{q}, p)^T \lambda = f_{\textrm{app}}(t, \hat{q}, \hat{u}, z, x, p) - f_{\textrm{inertial}}(\hat{q}, \hat{u}, p) &amp;&amp; \textrm{multibody dynamics} \\ &amp; \dot{z}_{\textrm{ex}}(t) = f_{\dot{z},\textrm{ex}}(t, \hat{q}, \hat{u}, z, x, \lambda, p) &amp;&amp; \textrm{auxiliary dynamics, explicit} \\ &amp; 0 = f_{\dot{z},\textrm{im}}(t, \hat{q}, \hat{u}, z, \dot{z}_\textrm{im}, x, \lambda, p) &amp;&amp; \textrm{auxiliary dynamics, implicit}\\ &amp; V_{L,k} \leq V_k(t_0, t_f, \hat{q}_0, \hat{q}_f, \hat{u}_0, \hat{u}_f, z_0, z_f, x_{0}, x_{f}, \lambda_0, \lambda_f, p, S_{b,k}) \leq V_{U,k} &amp;&amp; \textrm{boundary constraints} \\ &amp; \quad\quad S_{b,k} = \int_{t_0}^{t_f} s_{b,k}(t, \hat{q}, \hat{u}, z, x, \lambda, p)~dt \quad k = 1, \ldots, K \\ &amp; g_{L} \leq g(t, \hat{q}, \hat{u}, z, x, \lambda, p) \leq g_{U} &amp;&amp; \textrm{path constraints} \\ &amp; z_{0,L} \leq z_0 \leq z_{0,U} &amp;&amp; \textrm{initial auxiliary states} \\ &amp; z_{f,L} \leq z_f \leq z_{f,U} &amp;&amp; \textrm{final auxiliary states} \\ &amp; x_{0,L} \leq x_0 \leq x_{0,U} &amp;&amp; \textrm{initial controls} \\ &amp; x_{f,L} \leq x_f \leq x_{f,U} &amp;&amp; \textrm{final controls} \\ \mbox{with respect to} \quad &amp; t_0 \in [t_{0,L}, t_{0,U}] &amp;&amp; \textrm{initial time} \\ &amp; t_f \in [t_{f,L}, t_{f,U}] &amp;&amp; \textrm{final time} \\ &amp; z(t) \in [z_{L}, z_{U}] &amp;&amp; \textrm{auxiliary states} \\ &amp; x(t) \in [x_{L}, x_{U}] &amp;&amp; \textrm{controls} \\ &amp; \lambda(t) &amp;&amp; \textrm{Lagrange multipliers} \\ &amp; p \in [p_{L}, p_{U}]. &amp;&amp; \textrm{time-invariant parameters} \end{aligned} \end{align} \]
</p>
<p>The system still contains auxiliary state variables \( z \), control variables \( x \), and auxiliary dynamics. If none of the parameter variables affect the multibody system, then the multibody dynamics is reduced to a force balance: applied forces must match the net generalized forces determined by the kinematics (that is, inverse dynamics).</p>
<p>See <a class="el" href="mocodevguide.html#implpreskin">Prescribed kinematics</a> for more information.</p>
<h1><a class="anchor" id="dircol"></a>
Direct collocation</h1>
<p>The optimal control problems are solved using the direct collocation method. We provide a brief description of the method below; for a detailed explanation, see the following excellent material:</p>
<ul>
<li>Short paper: Kelly, M. (2017). An introduction to trajectory optimization: how to do your own direct collocation. SIAM Review, 59(4), 849-904. <a href="https://doi.org/10.1137/16M1062569">https://doi.org/10.1137/16M1062569</a></li>
<li>Textbook: Betts, J. T. (2010). Practical methods for optimal control and estimation using nonlinear programming (Vol. 19). Siam.</li>
</ul>
<h2><a class="anchor" id="mocotraptheory"></a>
Trapezoidal transcription</h2>
<p>With trapezoidal transcription, we discretize the continuous variables along \( n + 1 \) mesh points, leading to \( n \) mesh intervals:</p>
<p class="formulaDsp">
\[ \begin{alignat*}{1} 0 &amp;= \tau_0 &lt; \tau_1 &lt; \tau_2 &lt; \ldots &lt; \tau_i &lt; \ldots &lt; \tau_{n - 1} &lt; \tau_n = 1 \\ t_i &amp;= (t_f - t_0) \tau_i + t_0 \\ h_i &amp;= (t_f - t_0)(\tau_i - \tau_{i-1}) \end{alignat*} \]
</p>
<p>We use the trapezoidal rule to remove integrals and derivatives from the original continuous time problem,</p>
<p class="formulaDsp">
\[ \textrm{trap}_i(F(\eta, p)) = \frac{1}{2} h_i (F(\eta_{i-1}, p) + F(\eta_i, p)) \]
</p>
<p>where \( \eta \) is any continuous variable in the optimal control problem (e.g., \( y \)) and \( F \) is any function.</p>
<p>Combining the discretization with the trapezoidal rule yields the following finite-dimensional nonlinear optimization problem (or nonlinear program, abbreviated as NLP):</p>
<p class="formulaDsp">
\[ \begin{align} \begin{aligned} \mbox{minimize} \quad &amp; \sum_j w_j J_{j}(t_0, t_f, y_0, y_n, x_{0}, x_{n}, \lambda_0, \lambda_n, p, S_{c,j}) + w_{\lambda} \sum_{i=1}^{n} \textrm{trap}_i(\|\lambda\|_2^2) \\ &amp; \quad\quad S_{c,j} = \sum_{i=1}^{n} \textrm{trap}_i(s_{c,j}(t, y, x, \lambda, p)) \\ \mbox{subject to} \quad &amp; q_i = q_{i-1} + \textrm{trap}_i(u) &amp;&amp; i = 1, \ldots, n \\ &amp; u_i = u_{i-1} + \textrm{trap}_i(f_{\dot{u}}(t, y, x, \lambda, p)) &amp;&amp; i = 1, \ldots, n \\ &amp; z_{\textrm{ex},i} = z_{\textrm{ex},i-1} + \textrm{trap}_i(f_{\dot{z},\textrm{ex}}(t, y, x, \lambda, p)) &amp;&amp; i = 1, \ldots, n \\ &amp; z_{\textrm{im},i} = z_{\textrm{im},i-1} + \textrm{trap}_i(\zeta) &amp;&amp; i = 1, \ldots, n \\ &amp; 0 = f_{\dot{z},\textrm{im}}(t_i, y_i, \zeta_i, x_i, \lambda_i, p) &amp;&amp; i = 0, \ldots, n \\ &amp; 0 = \phi(q_i, p) &amp;&amp; i = 0, \ldots, n\\ &amp; V_{L,k} \leq V_k(t_0, t_f, y_0, y_f, x_{0}, x_{f}, \lambda_0, \lambda_f, p, S_{b,k}) \leq V_{U,k} \\ &amp; \quad\quad S_{b,k} = \sum_{i=1}^{n} \textrm{trap}_i(s_{b,k}(t, y, x, \lambda, p)) &amp;&amp; k = 1, \ldots, K \\ &amp; g_{L} \leq g(t_i, y_i, x_{i}, \lambda_i, p) \leq g_{U} &amp;&amp; i = 0, \ldots, n\\ \mbox{with respect to} \quad &amp; t_0 \in [t_{0,L}, t_{0,U}] &amp;&amp; t_n \in [t_{f,L}, t_{f,U}] \\ &amp; y_0 \in [y_{0,L}, y_{0,U}] &amp;&amp; y_n \in [y_{f,L}, y_{f,U}] \\ &amp; y_i \in [y_{L}, y_{U}] &amp;&amp; i = 1, \ldots, n - 1\\ &amp; \zeta_i \in [\zeta_{L}, \zeta_{U}] &amp;&amp; i = 0, \ldots, n \\ &amp; x_0 \in [x_{0,L}, x_{0,U}] &amp;&amp; x_n \in [x_{f,L}, x_{f,U}] \\ &amp; x_i \in [x_{L}, x_{U}] &amp;&amp; i = 1, \ldots, n - 1\\ &amp; \lambda_i \in [\lambda_L, \lambda_U] &amp;&amp; i = 0, \ldots, n \\ &amp; p \in [p_{L}, p_{U}]. \end{aligned} \end{align} \]
</p>
<p>Above, the multibody dynamics \( f_{\textrm{mb}} \) are expressed as explicit differential equations:</p>
<p class="formulaDsp">
\[ f_{\textrm{mb}}(t, y, x, \lambda, p) = M(q, p)^{-1}\big[(f_{\textrm{app}}(t, y, x, p) - f_{\textrm{inertial}}(q, u, p) - G(q, p)^T \lambda\big] \]
</p>
<p>If the multibody dynamics are enforced as implicit differential equations, then the constraint involving \( f_\textrm{mb} \) is replaced with the following:</p>
<p class="formulaDsp">
\[ \begin{alignat*}{2} \mbox{subject to} \quad &amp; u_i = u_{i-1} + \textrm{trap}_i(\upsilon) &amp; i = 1, \ldots, n \\ &amp; M(q_i, p)\upsilon_i + G(q_i, p)^T \lambda_i = f_{\textrm{app}}(t_i, y_i, x_{i}, p) - f_{\textrm{inertial}}(q_i, u_{i}, p) &amp; \quad i = 0, \ldots, n \\ \mbox{with respect to} \quad &amp; \upsilon_i \in [-\upsilon_{B}, \upsilon_{B}] &amp; i = 0, \ldots, n\\ \end{alignat*} \]
</p>
<p>where \( \upsilon \) (upsilon) is generalized acceleration and \( \upsilon_B \) is a large number.</p>
<p>Similar to implicit multibody dynamics, we enforce implicit auxiliary dynamics by introducing the variable \( \zeta \) for the derivative of the auxiliary state variable.</p>
<h2><a class="anchor" id="mocohermitesimpsontheory"></a>
Hermite–Simpson transcription</h2>
<p>With Hermite-Simpson transcription, we have \( n + 1 \) mesh points and \( n \) mesh intervals like Trapezoidal transcription, but we also introduce additional collocation points at the mesh interval midpoints. This leads to a total of \( 2n + 1 \) grid points on which we discretize the continuous variables:</p>
<p class="formulaDsp">
\[ \begin{alignat*}{1} 0 &amp;= \tau_0 &lt; \tau_1 &lt; \tau_2 &lt; \ldots &lt; \tau_i &lt; \ldots &lt; \tau_{n - 1} &lt; \tau_n = 1 \\ \bar{\tau}_i &amp;= 0.5 (\tau_{i-1} + \tau_i) \\ t_i &amp;= (t_f - t_0) \tau_i + t_0 \\ \bar{t}_i &amp;= (t_f - t_0) \bar{\tau}_i + t_0 \\ h_i &amp;= (t_f - t_0)(\tau_i - \tau_{i-1}) \\ \end{alignat*} \]
</p>
<p>where \( \bar{\tau}_i \) denote mesh interval midpoints.</p>
<p>Derivatives and integrals are removed from the original continuous time problem with the Hermite interpolant and Simpson integration rule:</p>
<p class="formulaDsp">
\[ \begin{align} \textrm{hermite}_i(\eta, F(\eta, p)) &amp;= \frac{1}{2} (\eta_{i-1} + \eta_i) + \frac{h_i}{8} (F(\eta_{i-1}, p) - F(\eta_i, p)) \\ \textrm{simpson}_i(F(\eta, p)) &amp;= \frac{h_i}{6} (F(\eta_{i-1}, p) + 4 F(\bar{\eta}_i, p) + F(\eta_i, p)) \end{align} \]
</p>
<p>where \( \eta \) is any continuous variable in the optimal control problem (e.g., \( y \)) and \( F \) is any function. Note the midpoint function evaluation in the Simpson integration rule.</p>
<p>The resulting finite-dimensional NLP is as follows:</p>
<p class="formulaDsp">
\[ \begin{align} \begin{aligned} \mbox{minimize} \quad &amp; \sum_j w_j J_{c,j}(t_0, t_f, y_0, y_n, x_{0}, x_{n}, \lambda_0, \lambda_n, p, S_{c,j}) + w_{\lambda} \sum_{i=1}^{n} \textrm{simpson}_i(\|\lambda\|_2^2) \\ &amp; \quad\quad S_{c,j} = \sum_{i=1}^{n} \textrm{simpson}_i(s_{c,j}(t, y, x, \lambda, p)) \\ \mbox{subject to} \quad &amp; \bar{q}_i = \textrm{hermite}_i(q, u) + G(\bar{q}_i, p)^T \bar{\gamma}_i &amp;&amp; i = 1, \ldots, n \\ &amp; q_i = q_{i-1} + \textrm{simpson}_i(u) &amp;&amp; i = 1, \ldots, n \\ &amp; \bar{u}_i = \textrm{hermite}_i(u, f_{\dot{u}}(t, y, x, \lambda, p)) &amp;&amp; i = 1, \ldots, n \\ &amp; u_i = u_{i-1} + \textrm{simpson}_i(f_{\dot{u}}(t, y, x, \lambda, p)) &amp;&amp; i = 1, \ldots, n \\ &amp; \bar{z}_{\textrm{ex},i} = \textrm{hermite}_i(z_{\textrm{ex}}, f_{\dot{z},\textrm{ex}}(t, y, x, \lambda, p)) &amp;&amp; i = 1, \ldots, n \\ &amp; z_{\textrm{ex},i} = z_{\textrm{ex},i-1} + \textrm{simpson}_i(f_{\dot{z},\textrm{ex}}(t, y, x, \lambda, p)) &amp;&amp; i = 1, \ldots, n \\ &amp; \bar{z}_{\textrm{im},i} = \textrm{hermite}_i(z_{\textrm{im}}, \zeta) &amp;&amp; i = 1, \ldots, n \\ &amp; z_{\textrm{im},i} = z_{\textrm{im},i-1} + \textrm{simpson}_i(\zeta) &amp;&amp; i = 1, \ldots, n \\ &amp; 0 = f_{\dot{z},\textrm{im}}(t_i, y_i, \zeta_i, x_i, \lambda_i, p) &amp;&amp; i = 0, \ldots, n \\ &amp; \bar{x}_i = (x_{i-1} + x_i)/2 &amp;&amp; i = 1, \ldots, n \\ &amp; 0 = \phi(q_i, p) &amp;&amp; i = 0, \ldots, n\\ &amp; 0 = \dot{\phi}(q_i, u_i, p) &amp;&amp; i = 0, \ldots, n\\ &amp; 0 = \ddot{\phi}(t_i, y_i, x_i, \lambda_i, p) &amp;&amp; i = 0, \ldots, n\\ &amp; V_{L,k} \leq V_k(t_0, t_f, y_0, y_f, x_{0}, x_{f}, \lambda_0, \lambda_f, p, S_{b,k}) \leq V_{U,k} \\ &amp; \quad\quad S_{b,k} = \sum_{i=1}^{n} \textrm{simpson}_i(s_{b,k}(t, y, x, \lambda, p)) &amp;&amp; k = 1, \ldots, K \\ &amp; g_{L} \leq g(t_i, y_i, x_{i}, \lambda_i, p) \leq g_{U} &amp;&amp; i = 0, \ldots, n\\ \mbox{with respect to} \quad &amp; t_0 \in [t_{0,L}, t_{0,U}] &amp;&amp; t_n \in [t_{f,L}, t_{f,U}] \\ &amp; y_0 \in [y_{0,L}, y_{0,U}] &amp;&amp; y_n \in [y_{f,L}, y_{f,U}] \\ &amp; y_i \in [y_{L}, y_{U}] &amp;&amp; i = 1, \ldots, n - 1 \\ &amp; \bar{y}_i \in [y_{L}, y_{U}] &amp;&amp; i = 1, \ldots, n \\ &amp; \zeta_i \in [\zeta_{L}, \zeta_{U}] &amp;&amp; i = 0, \ldots, n \\ &amp; \bar{\zeta}_i \in [\zeta_{L}, \zeta_{U}] &amp;&amp; i = 1, \ldots, n \\ &amp; x_0 \in [x_{0,L}, x_{0,U}] &amp;&amp; x_n \in [x_{f,L}, x_{f,U}] \\ &amp; x_i \in [x_{L}, x_{U}] &amp;&amp; i = 1, \ldots, n - 1 \\ &amp; \bar{x}_i \in [x_{L}, x_{U}] &amp;&amp; i = 1, \ldots, n \\ &amp; \lambda_i \in [\lambda_L, \lambda_U] &amp;&amp; i = 0, \ldots, n \\ &amp; \bar{\lambda}_i \in [\lambda_L, \lambda_U] &amp;&amp; i = 1, \ldots, n \\ &amp; \bar{\gamma}_i \in [\bar{\gamma}_L, \bar{\gamma}_U] &amp;&amp; i = 1, \ldots, n \\ &amp; p \in [p_{L}, p_{U}]. \end{aligned} \end{align} \]
</p>
<p>The explicit multibody dynamics function \( f_{\textrm{mb}} \) is the same as in Trapezoidal transcription.</p>
<p>The \( G(\bar{q}_i, p)^T \bar{\gamma}_i \) term represents a velocity correction that is necessary to impose when enforcing derivatives of kinematic constraints in the NLP. The additional variables \( \bar{\gamma}_i \) help avoid problems becoming overconstrained, and the kinematic Jacobian transpose operator, \( G(\bar{q}_i, p)^T \), restricts the velocity correction to the tangent plane of the constraint manifold (see Posa et al. 2016 described in <a class="el" href="mocostudy.html#kincon">Kinematic constraints</a> for more details). Currently, we only support enforcing derivatives of position-level, or holonomic, constraints, represented by the equations:</p>
<p class="formulaDsp">
\[ \begin{alignat*}{2} &amp; 0 = \dot{\phi}(q, u, p) = G(q, p) u\\ &amp; 0 = \ddot{\phi}(t, y, x, \lambda, p) = G(q, p) f_{\textrm{mb}}(t, y, x, \lambda, p) + \dot{G}(q, p) u \\ \end{alignat*} \]
</p>
<p>The explicit multibody dynamics function is used here where \( \dot{u} \) would be if it were a continuous variable in the problem (as is in implicit mode, see below).</p>
<p>Even though <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> supports non-holonomic constraints (that is, \( \nu(q, u, p) = 0 \)), we only support holonomic constraints; that is, \( \phi(q) = 0 \).</p>
<p>The implicit dynamics formulation is as follows:</p>
<p class="formulaDsp">
\[ \begin{alignat*}{2} \mbox{subject to} \quad &amp; \bar{u}_i = \textrm{hermite}_i(u, \upsilon) &amp; i = 1, \ldots, n \\ &amp; u_i = u_{i-1} + \textrm{simpson}_i(\upsilon) &amp; i = 1, \ldots, n \\ &amp; M(q_i, p)\upsilon_i + G(q_i, p)^T \lambda_i = f_{\textrm{app}}(t_i, y_i, x_{i}, p) - f_{\textrm{inertial}}(q_i, u_{i}, p) &amp; \quad i = 0, \ldots, n \\ &amp; M(\bar{q}_i, p)\bar{\upsilon}_i + G(\bar{q}_i, p)^T \bar{\lambda}_i = f_{\textrm{app}}(\bar{t}_i, \bar{y}_i, \bar{x}_{i}, p) - f_{\textrm{inertial}}(\bar{q}_i, \bar{u}_i, p) &amp; \quad i = 1, \ldots, n \\ \mbox{with respect to} \quad &amp; \upsilon_i \in [-\upsilon_{B}, \upsilon_{B}] &amp; i = 0, \ldots, n \\ &amp; \bar{\upsilon}_i \in [-\upsilon_{B}, \upsilon_{B}] &amp; i = 1, \ldots, n \end{alignat*} \]
</p>
 </div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="mocomainpage.html">Moco</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:16 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
